(* Title:  Knowledge/Inverse_Z_Transform/inverse_z_transform.sml
   Author: Jan Rocnik
   (c) copyright due to lincense terms.
12345678901234567890123456789012345678901234567890123456789012345678901234567890
        10        20        30        40        50        60        70        80
*)

"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- met/pbl [SignalProcessing,Z_Transform,inverse] known ";
"----------- syntax [SignalProcessing,Z_Transform,inverse_sub] ---";
"----------- test [SignalProcessing,Z_Transform,inverse_sub] me = ";
"----------- test [SignalProcessing,Z_Transform,inverse_sub] autoc";
"----------- test [SignalProcessing,Z_Transform,inverse] autocalc-";
"----------- [Signal..,inverse] (Step 1): <ISA> rhs (?X' z = ... -";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";

"----------- met/pbl [SignalProcessing,Z_Transform,inverse] known ";
"----------- met/pbl [SignalProcessing,Z_Transform,inverse] known ";
"----------- met/pbl [SignalProcessing,Z_Transform,inverse] known ";
get_pbt ["Inverse","Z_Transform","SignalProcessing"];
get_met ["SignalProcessing","Z_Transform","Inverse"];

"----------- syntax [SignalProcessing,Z_Transform,inverse_sub] ---";
"----------- syntax [SignalProcessing,Z_Transform,inverse_sub] ---";
"----------- syntax [SignalProcessing,Z_Transform,inverse_sub] ---";
val str =    
"Script InverseZTransform (X_eq::bool) =            "^(*([], Frm), Problem (Isac, [Inverse, Z_Transform, SignalProcessing])*)
   "(let X = Take X_eq;                                "^(*([1], Frm), X z = 3 / (z - 1 / 4 + -1 / 8 * (1 / z))*)
   "  X' = Rewrite ruleZY False X;                     "^(*([1], Res), ?X' z = 3 / (z * (z - 1 / 4 + -1 / 8 * (1 / z)))*)
   "  (X'_z::real) = lhs X';                           "^(*            ?X' z*)
   "  (zzz::real) = argument_in X'_z;                  "^(*            z *)
   "  (funterm::real) = rhs X';                        "^(*            3 / (z * (z - 1 / 4 + -1 / 8 * (1 / z)))*)

   "  (pbz::real) = (SubProblem (Isac',                "^(**)
   "    [partial_fraction,rational,simplification],    "^
   "    [simplification,of_rationals,to_partial_fraction]) "^
   "    [REAL funterm, REAL zzz]);                     "^(*([2], Res), 4 / (z - 1 / 2) + -4 / (z - -1 / 4)*)

   "  (pbz_eq::bool) = Take (X'_z = pbz);              "^(*([3], Frm), ?X' z = 4 / (z - 1 / 2) + -4 / (z - -1 / 4)*)
   "  pbz_eq = Rewrite ruleYZ False pbz_eq;            "^(*([3], Res), ?X' z = 4 * (?z / (z - 1 / 2)) + -4 * (?z / (z - -1 / 4))*)
   "  pbz_eq = drop_questionmarks pbz_eq;              "^(*               4 * (z / (z - 1 / 2)) + -4 * (z / (z - -1 / 4))*)
   "  (X_zeq::bool) = Take (X_z = rhs pbz_eq);         "^(*([4], Frm), X_z = 4 * (z / (z - 1 / 2)) + -4 * (z / (z - -1 / 4))*)
   "  n_eq = (Rewrite_Set inverse_z False) X_zeq;      "^(*([4], Res), X_z = 4 * (1 / 2) ^^^ ?n * ?u [?n] + -4 * (-1 / 4) ^^^ ?n * ?u [?n]*)
   "  n_eq = drop_questionmarks n_eq                   "^(*            X_z = 4 * (1 / 2) ^^^ n * u [n] + -4 * (-1 / 4) ^^^ n * u [n]*)
   "in n_eq)"                                            (*([], Res), X_z = 4 * (1 / 2) ^^^ n * u [n] + -4 * (-1 / 4) ^^^ n * u [n]*)
;
val sc = ((inst_abs thy) o Thm.term_of o the o (parse @{theory Isac})) str;
writeln (term2str sc);

"----------- test [SignalProcessing,Z_Transform,inverse_sub] me = ";
"----------- test [SignalProcessing,Z_Transform,inverse_sub] me = ";
"----------- test [SignalProcessing,Z_Transform,inverse_sub] me = ";
val fmz = ["filterExpression (X z = 3 / (z - 1/4 + -1/8 * (1/(z::real))))",
  "stepResponse (x[n::real]::bool)"];
val (dI, pI, mI) = ("Isac", ["Inverse", "Z_Transform", "SignalProcessing"], 
   ["SignalProcessing", "Z_Transform", "Inverse_sub"]);
val (p,_,fb,nxt,_,pt)  = CalcTreeTEST [(fmz, (dI,pI,mI))]; (*Model_Problem*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Add_Given "filterExpression (X z = ...*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Add_Given "filterExpression (X z = *)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Add_Find "stepResponse (x [n])")*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Specify_Problem*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Specify_Method*) 
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Apply_Me["SignalProcessing","Z_Transform","Inverse_sub"]*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Rewrite ("ruleZY", "Inverse_Z_Transform.ruleZY")*)
                          (*([1], Frm)*)f2str fb="X z = 3 / (z - 1 / 4 + -1 / 8 * (1 / z))";
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Subproblem ("Isac", ["partial_fraction", "rational..*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Model_Problem*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Add_Given "functionTerm (X' z)"*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Add_Given "solveFor z"*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Add_Find "decomposedFunction p_p'''"*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Specify_Theory*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Specify_Problem*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Specify_Method*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Apply_Method
                                         ["simplification", "of_rationals", "to_partial_fraction"]*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Rewrite_Set "norm_Rational"*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Subproblem ("Isac", ["abcFormula", "degree_2", "po...a*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Apply_Method ["PolyEq", "solve_d2_polyeq_abc_equation"*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
if f2str fb = "-1 + -2 * z + 8 * z ^^^ 2 = 0"andalso p = ([2, 2, 1], Frm)
then () else error "begin of 'inv Z', exp 1 me changed";
show_pt pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Check_Postcond", ...*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*"Substitute*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Subproblem*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Apply_Method ["PolyEq", "normalize_poly"]*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Subproblem*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Apply_Method ["PolyEq", "solve_d1_polyeq_equation"]*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Check_Postcond *)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Check_Postcond *)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Subproblem*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Apply_Method ["PolyEq", "normalize_poly"]*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Subproblem*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Apply_Method ["PolyEq", "solve_d1_polyeq_equation"]*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Check_Postcond*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Check_Postcond*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (**)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*([2, 11], Res) Check_Postcond*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*([2], Res) Take*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*([3], Frm) Rewrite*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*([3], Res) Take*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Rewrite_Set*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*Check_Postcond*)
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; (*End_Proof*)
if p = ([], Res) andalso f2str fb = "X_z = 4 * (1 / 2) ^^^ n * u [n] + -4 * (-1 / 4) ^^^ n * u [n]"
then () else error "z-trans (X z = 3 / (z - 1/4 + -1/8 * (1/(z::real)))) changed";
show_pt pt;
(* [
(([], Frm), Problem (Isac, [Inverse, Z_Transform, SignalProcessing])),
(([1], Frm), X z = 3 / (z - 1 / 4 + -1 / 8 * (1 / z))),
(([1], Res), ?X' z = 3 / (z * (z - 1 / 4 + -1 / 8 * (1 / z)))),
(([2], Pbl), Problem (Isac, [partial_fraction, rational, simplification])),
(([2,1], Frm), 3 / (z * (z - 1 / 4 + -1 / 8 * (1 / z)))),
(([2,1], Res), 24 / (-1 + -2 * z + 8 * z ^^^ 2)),
(([2,2], Pbl), solve (-1 + -2 * z + 8 * z ^^^ 2 = 0, z)),
(([2,2,1], Frm), -1 + -2 * z + 8 * z ^^^ 2 = 0),
(([2,2,1], Res), z = (- -2 + sqrt (-2 ^^^ 2 - 4 * 8 * -1)) / (2 * 8) |
z = (- -2 - sqrt (-2 ^^^ 2 - 4 * 8 * -1)) / (2 * 8)),
(([2,2,2], Res), z = 1 / 2 | z = -1 / 4),
(([2,2,3], Res), [z = 1 / 2, z = -1 / 4]),
(([2,2,4], Res), [z = 1 / 2, z = -1 / 4]),
(([2,2], Res), [z = 1 / 2, z = -1 / 4]),
(([2,3], Frm), 3 / ((z - 1 / 2) * (z - -1 / 4))),
(([2,3], Res), ?A / (z - 1 / 2) + ?B / (z - -1 / 4)),
(([2,4], Frm), 3 / ((z - 1 / 2) * (z - -1 / 4)) = ?A / (z - 1 / 2) + ?B / (z - -1 / 4)),
(([2,4], Res), 3 = ?A * (z - -1 / 4) + ?B * (z - 1 / 2)),
(([2,5], Frm), 3 = A * (z - -1 / 4) + B * (z - 1 / 2)),
(([2,5], Res), 3 = A * (1 / 2 - -1 / 4) + B * (1 / 2 - 1 / 2)),
(([2,6], Res), 3 = 3 * A / 4),
(([2,7], Pbl), solve (3 = 3 * A / 4, A)),
(([2,7,1], Frm), 3 = 3 * A / 4),
(([2,7,1], Res), 3 - 3 * A / 4 = 0),
(([2,7,2], Res), 3 / 1 + -3 / 4 * A = 0),
(([2,7,3], Res), 3 + -3 / 4 * A = 0),
(([2,7,4], Pbl), solve (3 + -3 / 4 * A = 0, A)),
(([2,7,4,1], Frm), 3 + -3 / 4 * A = 0),
(([2,7,4,1], Res), A = -1 * 3 / (-3 / 4)),
(([2,7,4,2], Res), A = -3 / (-3 / 4)),
(([2,7,4,3], Res), A = 4),
(([2,7,4,4], Res), [A = 4]),
(([2,7,4,5], Res), [A = 4]),
(([2,7,4], Res), [A = 4]),
(([2,7], Res), [A = 4]),
(([2,8], Frm), 3 = A * (z - -1 / 4) + B * (z - 1 / 2)),
(([2,8], Res), 3 = A * (-1 / 4 - -1 / 4) + B * (-1 / 4 - 1 / 2)),
(([2,9], Res), 3 = -3 * B / 4),
(([2,10], Pbl), solve (3 = -3 * B / 4, B)),
(([2,10,1], Frm), 3 = -3 * B / 4),
(([2,10,1], Res), 3 - -3 * B / 4 = 0),
(([2,10,2], Res), 3 / 1 + 3 / 4 * B = 0),
(([2,10,3], Res), 3 + 3 / 4 * B = 0),
(([2,10,4], Pbl), solve (3 + 3 / 4 * B = 0, B)),
(([2,10,4,1], Frm), 3 + 3 / 4 * B = 0),
(([2,10,4,1], Res), B = -1 * 3 / (3 / 4)),
(([2,10,4,2], Res), B = -3 / (3 / 4)),
(([2,10,4,3], Res), B = -4),
(([2,10,4,4], Res), [B = -4]),
(([2,10,4,5], Res), [B = -4]),
(([2,10,4], Res), [B = -4]),
(([2,10], Res), [B = -4]),
(([2,11], Frm), A / (z - 1 / 2) + B / (z - -1 / 4)),
(([2,11], Res), 4 / (z - 1 / 2) + -4 / (z - -1 / 4)),
(([2], Res), 4 / (z - 1 / 2) + -4 / (z - -1 / 4)),
(([3], Frm), ?X' z = 4 / (z - 1 / 2) + -4 / (z - -1 / 4)),
(([3], Res), ?X' z = 4 * (?z / (z - 1 / 2)) + -4 * (?z / (z - -1 / 4))),
(([4], Frm), X_z = 4 * (z / (z - 1 / 2)) + -4 * (z / (z - -1 / 4))),
(([4], Res), X_z = 4 * (1 / 2) ^^^ ?n * ?u [?n] + -4 * (-1 / 4) ^^^ ?n * ?u [?n]),
(([], Res), X_z = 4 * (1 / 2) ^^^ n * u [n] + -4 * (-1 / 4) ^^^ n * u [n])] 
*)

"----------- test [SignalProcessing,Z_Transform,inverse_sub] autoc";
"----------- test [SignalProcessing,Z_Transform,inverse_sub] autoc";
"----------- test [SignalProcessing,Z_Transform,inverse_sub] autoc";
reset_states ();
val fmz = ["filterExpression (X z = 3 / (z - 1/4 + -1/8 * (1/(z::real))))",
  "stepResponse (x[n::real]::bool)"];
val (dI, pI, mI) = ("Isac", ["Inverse", "Z_Transform", "SignalProcessing"], 
   ["SignalProcessing", "Z_Transform", "Inverse_sub"]);
CalcTree [(fmz, (dI,pI,mI))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalc; 

val ((pt,_),_) = get_calc 1; val p = get_pos 1 1;
val (Form f, tac, asms) = pt_extract (pt, p);
if term2str f = "X_z = 4 * (1 / 2) ^^^ n * u [n] + -4 * (-1 / 4) ^^^ n * u [n]"
  andalso p = ([], Res) then ()
  else error "inv Z, exp 1 autoCalculate changed"


"----------- test [SignalProcessing,Z_Transform,inverse] autocalc-";
"----------- test [SignalProcessing,Z_Transform,inverse] autocalc-";
"----------- test [SignalProcessing,Z_Transform,inverse] autocalc-";
reset_states ();
val fmz = ["filterExpression (X z = 3 / (z - 1/4 + -1/8 * (1/(z::real))))",
  "stepResponse (x[n::real]::bool)"];
val (dI, pI, mI) = ("Isac", ["Inverse", "Z_Transform", "SignalProcessing"], 
   ["SignalProcessing", "Z_Transform", "Inverse"]);
CalcTree [(fmz, (dI,pI,mI))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalc; 

val ((pt,_),_) = get_calc 1; val p = get_pos 1 1;
val (Form f, tac, asms) = pt_extract (pt, p);
if term2str f = "X_z = 4 * (1 / 2) ^^^ n * u [n] + -4 * (-1 / 4) ^^^ n * u [n]"
  andalso p = ([], Res) then ()
  else error "inv Z, exp 1 autoCalculate changed"

show_pt pt;
(*[
(([], Frm), Problem (Isac, [Inverse, Z_Transform, SignalProcessing])),
(([1], Frm), X z = 3 / (z - 1 / 4 + -1 / 8 * (1 / z))),
(([1], Res), ?X' z = 3 / (z * (z - 1 / 4 + -1 / 8 * (1 / z)))),
(([2], Res), ?X' z = 24 / (-1 + -2 * z + 8 * z ^^^ 2)),
(([3], Pbl), solve (-1 + -2 * z + 8 * z ^^^ 2 = 0, z)),
(([3,1], Frm), -1 + -2 * z + 8 * z ^^^ 2 = 0),
(([3,1], Res), z = (- -2 + sqrt (-2 ^^^ 2 - 4 * 8 * -1)) / (2 * 8) |
z = (- -2 - sqrt (-2 ^^^ 2 - 4 * 8 * -1)) / (2 * 8)),
(([3,2], Res), z = 1 / 2 | z = -1 / 4),
(([3,3], Res), [z = 1 / 2, z = -1 / 4]),
(([3,4], Res), [z = 1 / 2, z = -1 / 4]),
(([3], Res), [z = 1 / 2, z = -1 / 4]),
(([4], Frm), 3 / ((z - 1 / 2) * (z - -1 / 4))),
(([4], Res), ?A / (z - 1 / 2) + ?B / (z - -1 / 4)),
(([5], Frm), 3 / ((z - 1 / 2) * (z - -1 / 4)) = ?A / (z - 1 / 2) + ?B / (z - -1 / 4)),
(([5], Res), 3 = ?A * (z - -1 / 4) + ?B * (z - 1 / 2)),
(([6], Frm), 3 = A * (z - -1 / 4) + B * (z - 1 / 2)),
(([6], Res), 3 = A * (1 / 2 - -1 / 4) + B * (1 / 2 - 1 / 2)),
(([7], Res), 3 = 3 * A / 4),
(([8], Pbl), solve (3 = 3 * A / 4, A)),
(([8,1], Frm), 3 = 3 * A / 4),
(([8,1], Res), 3 - 3 * A / 4 = 0),
(([8,2], Res), 3 / 1 + -3 / 4 * A = 0),
(([8,3], Res), 3 + -3 / 4 * A = 0),
(([8,4], Pbl), solve (3 + -3 / 4 * A = 0, A)),
(([8,4,1], Frm), 3 + -3 / 4 * A = 0),
(([8,4,1], Res), A = -1 * 3 / (-3 / 4)),
(([8,4,2], Res), A = -3 / (-3 / 4)),
(([8,4,3], Res), A = 4),
(([8,4,4], Res), [A = 4]),
(([8,4,5], Res), [A = 4]),
(([8,4], Res), [A = 4]),
(([8], Res), [A = 4]),
(([9], Frm), 3 = A * (z - -1 / 4) + B * (z - 1 / 2)),
(([9], Res), 3 = A * (-1 / 4 - -1 / 4) + B * (-1 / 4 - 1 / 2)),
(([10], Res), 3 = -3 * B / 4),
(([11], Pbl), solve (3 = -3 * B / 4, B)),
(([11,1], Frm), 3 = -3 * B / 4),
(([11,1], Res), 3 - -3 * B / 4 = 0),
(([11,2], Res), 3 / 1 + 3 / 4 * B = 0),
(([11,3], Res), 3 + 3 / 4 * B = 0),
(([11,4], Pbl), solve (3 + 3 / 4 * B = 0, B)),
(([11,4,1], Frm), 3 + 3 / 4 * B = 0),
(([11,4,1], Res), B = -1 * 3 / (3 / 4)),
(([11,4,2], Res), B = -3 / (3 / 4)),
(([11,4,3], Res), B = -4),
(([11,4,4], Res), [B = -4]),
(([11,4,5], Res), [B = -4]),
(([11,4], Res), [B = -4]),
(([11], Res), [B = -4]),
(([12], Frm), A / (z - 1 / 2) + B / (z - -1 / 4)),
(([12], Res), 4 / (z - 1 / 2) + -4 / (z - -1 / 4)),
(([13], Res), 4 * (?z / (z - 1 / 2)) + -4 * (?z / (z - -1 / 4))),
(([14], Frm), X_z = 4 * (z / (z - 1 / 2)) + -4 * (z / (z - -1 / 4))),
(([14], Res), X_z = 4 * (1 / 2) ^^^ ?n * ?u [?n] + -4 * (-1 / 4) ^^^ ?n * ?u [?n]),
(([], Res), X_z = 4 * (1 / 2) ^^^ n * u [n] + -4 * (-1 / 4) ^^^ n * u [n])] *)

"----------- [Signal..,inverse] (Step 1): <ISA> rhs (?X' z = ... -";
"----------- [Signal..,inverse] (Step 1): <ISA> rhs (?X' z = ... -";
"----------- [Signal..,inverse] (Step 1): <ISA> rhs (?X' z = ... -";
(*====================================================================
(* Below are _all_ steps from BridgeLog; _superfluous_ ones and output are text. 
  REASON FOR THE ERROR: Inverse_Z_Transform.thy did not contain final version of method.

[[to sml: theory TTY_Communication imports Isac begin 
ML {* reset_states (); *}
*)
ML {* CalcTree [(["filterExpression (X z = 3 / (z - 1/4 + -1/8 * (1/(z::real))))",
    "stepResponse (x[n::real]::bool)"],("Isac",["Inverse","Z_Transform","SignalProcessing"],
    ["SignalProcessing","Z_Transform","Inverse"]))]; *}
ML {* Iterator 1; *}
ML {* moveActiveRoot 1; *}
ML {* getFormulaeFromTo 1 ([],Pbl) ([],Pbl) 0 false; *}
text {* getFormulaeFromTo 1 ([],Pbl) ([],Pbl) 0 false; *}
ML {* "##### 1.<NEXT> ############################################" *}
ML {* (*completeCalcHead*)autoCalculate 1 CompleteCalcHead; *}
text {* (*completeCalcHead*)getActiveFormula 1 ; *}
text {* (*completeCalcHead*)refFormula 1 ([],Met); *}
text {* refFormula 1 ([],Pbl); *}
text {* fetchProposedTactic 1; *}
ML {* autoCalculate 1 (Step 1); *}
text {* getFormulaeFromTo 1 ([],Met) ([1],Frm) 0 false; *}
text {* getFormulaeFromTo 1 ([],Met) ([1],Frm) 0 false; *}
ML {* refFormula 1 ([1],Frm); *}
text {*<ISA> ?X' z = 3 / (z * (z - 1 / 4 + -1 / 8 * (1 / z))) </ISA>*}
text {* refFormula 1 ([1],Frm); *}
ML {* "##### 2.<NEXT> ############################################" *}
text {* refFormula 1 ([1],Frm); *}
ML {* autoCalculate 1 (Step 1); *}
text {* getFormulaeFromTo 1 ([1],Frm) ([1],Res) 0 false; *}
text {* getFormulaeFromTo 1 ([1],Frm) ([1],Res) 0 false; *}
ML {* refFormula 1 ([1],Res); *}
text {*<ISA> ?X' z = 3 / (z * (z - 1 / 4 + -1 / 8 * (1 / z))) </ISA>*}
ML {* refFormula 1 ([1],Res); *}
ML {* "##### 3.<NEXT> ############################################" *}
text {* refFormula 1 ([1],Res); *}
ML {* autoCalculate 1 (Step 1); *}
text {* getFormulaeFromTo 1 ([1],Res) ([2],Res) 0 false; *}
text {* getFormulaeFromTo 1 ([1],Res) ([2],Res) 0 false; *}
ML {* refFormula 1 ([2],Res); *}
text {*<ISA> rhs (?X' z = 24 / (-1 + -2 * z + 8 * z ^ 2)) </ISA>*}
text {* refFormula 1 ([2],Res); *}
ML {* "##### 4.<NEXT> ############################################" *}
text {* refFormula 1 ([2],Res); *}
ML {* autoCalculate 1 (Step 1); *}
text {* getFormulaeFromTo 1 ([2],Res) ([3],Frm) 0 false; *}
text {* getFormulaeFromTo 1 ([2],Res) ([3],Frm) 0 false; *}
ML {* refFormula 1 ([3],Frm); *}
text {*<ISA> rhs (?X' z = 24 / (-1 + -2 * z + 8 * z ^ 2)) </ISA>*}
text {* refFormula 1 ([3],Frm); *}
ML {* "##### 5.<NEXT> ############################################" *}
text {* refFormula 1 ([3],Frm); *}
ML {* autoCalculate 1 (Step 1); *}
text {*<CALCMESSAGE> helpless </CALCMESSAGE>*}
====================================================================*)


