(* tests on Atools.thy and Atools.ML
   author: Walther Neuper
   050814, 08:51
   (c) due to copyright terms

use"../smltest/IsacKnowledge/atools.sml";
use"atools.sml";
*)

default_print_depth 5;
"--------------------------------------------------------";
"table of contents --------------------------------------";
"--------------------------------------------------------";
"----------- occurs_in ----------------------------------";
"----------- argument_of --------------------------------";
"----------- sameFunId ----------------------------------";
"----------- filter_sameFunId ---------------------------";
"----------- boollist2sum -------------------------------";
"----------- Matthias Goldgruber 2003 rewrite orders ----";
(*"----------- introduction by MG 2003 --------------------";*)
"----------- fun eval_binop -----------------------------";
"--------------------------------------------------------";


val thy = @{theory "Atools"};

"----------- occurs_in -------------------------------------------";
"----------- occurs_in -------------------------------------------";
"----------- occurs_in -------------------------------------------";
(*=========================================================================*)
fun str2t str = (Thm.term_of o the o (parse thy)) str;
fun term2s t = term_to_string''' thy t;
(*=========================================================================*)

val t = str2t "x";
if occurs_in t t then "OK" else error "occurs_in x x -> f ..changed";

val t = str2term "x occurs_in x";
val SOME (str, t') = eval_occurs_in 0 "Atools.occurs'_in" t 0;
if term2str t' = "x occurs_in x = True" then ()
else error "x occurs_in x = True ..changed";

"------- some_occur_in";
some_occur_in [str2t"c",str2t"c_2"] (str2t"a + b + c");
val t = str2t "some_of [c, c_2, c_3, c_4] occur_in \
		 \-1 * q_0 * L ^^^ 2 / 2 + L * c + c_2";
val SOME (str,t') = eval_some_occur_in 0 "Atools.some'_occur'_in" t 0;
if term2str t' =
   "some_of [c, c_2, c_3, c_4] occur_in -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2 =\nTrue" then ()
else error "atools.sml: some_occur_in true";

val t = str2t "some_of [c_3, c_4] occur_in \
		 \-1 * q_0 * L ^^^ 2 / 2 + L * c + c_2";
val SOME (str,t') = eval_some_occur_in 0 "Atools.some'_occur'_in" t 0;
if term2str t' =
   "some_of [c_3, c_4] occur_in -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2 = False" then ()
else error "atools.sml: some_occur_in false";

"----------- argument_of -----------------------------------------";
"----------- argument_of -----------------------------------------";
"----------- argument_of -----------------------------------------";
val t = str2term "argument_in (M_b x)";
val SOME (str, t') = eval_argument_in 0 "Atools.argument'_in" t 0;
if term2str t' = "(argument_in M_b x) = x" then ()
else error "atools.sml:(argument_in M_b x) = x  ???";

"----------- sameFunId -------------------------------------------";
"----------- sameFunId -------------------------------------------";
"----------- sameFunId -------------------------------------------";
val t = str2t "M_b L"; atomty t;
val t as f1 $ _ = str2t "M_b L";
val t as Const ("HOL.eq", _) $ (f2 $ _) $ _ = str2t "M_b x = c + L*x";
f1 = f2 (*true*);
val (p as Const ("Atools.sameFunId",_) $ 
			(f1 $ _) $ 
			(Const ("HOL.eq", _) $ (f2 $ _) $ _)) = 
    str2t "sameFunId (M_b L) (M_b x = c + L*x)";
f1 = f2 (*true*);
eval_sameFunId "" "Atools.sameFunId" 
		 (str2t "sameFunId (M_b L) (M_b x = c + L*x)")""(*true*);
eval_sameFunId "" "Atools.sameFunId" 
		 (str2t "sameFunId (M_b L) ( y' x = c + L*x)")""(*false*);
eval_sameFunId "" "Atools.sameFunId" 
		 (str2t "sameFunId (M_b L) (  y x = c + L*x)")""(*false*);
eval_sameFunId "" "Atools.sameFunId" 
		 (str2t "sameFunId (  y L) (M_b x = c + L*x)")""(*false*);
eval_sameFunId "" "Atools.sameFunId" 
		 (str2t "sameFunId (  y L) (  y x = c + L*x)")""(*true*);

"----------- filter_sameFunId ------------------------------------";
"----------- filter_sameFunId ------------------------------------";
"----------- filter_sameFunId ------------------------------------";
val flhs as (fid $ _) = str2t "y' L";
val fs = str2t "[M_b x = c + L*x, y' x = c + L*x, y x = c + L*x]";
val (p as Const ("Atools.filter'_sameFunId",_) $ (fid $ _) $ fs) = 
    str2t "filter_sameFunId (y' L) \
	     \[M_b x = c + L*x, y' x = c + L*x, y x = c + L*x]";
val SOME (str, es) = eval_filter_sameFunId "" "Atools.filter'_sameFunId" p "";
if term2str es = "(filter_sameFunId y' L [M_b x = c + L * x, y' x = c + L * x,\n                        y x = c + L * x]) =\n[y' x = c + L * x]" then ()
else error "atools.slm diff.behav. in filter_sameFunId";


"----------- boollist2sum ----------------------------------------";
"----------- boollist2sum ----------------------------------------";
"----------- boollist2sum ----------------------------------------";
fun lhs (Const ("HOL.eq",_) $ l $ _) = l
  | lhs t = error("lhs called with (" ^ term2str t ^ ")");
"-----------^^^redefined due to overwritten identifier -----------";
val u_ = str2t "[]";
val u_ = str2t "[b1 = k - 2*q]";
val u_ = str2t "[b1 = k - 2*q, b2 = k - 2*q, b3 = k - 2*q, b4 = k - 2*q]";
val ut_ = isalist2list u_;
val sum_ = map lhs ut_;
val t = list2sum sum_;
term2str t;

val t = str2t 
       "boollist2sum [b1 = k - 2*q, b2 = k - 2*q, b3 = k - 2*q, b4 = k - 2*q]";

val p as Const ("Atools.boollist2sum", _) $ (Const ("List.list.Cons", _) $
						   _ $ _) = t;


val SOME (str, pred) = eval_boollist2sum "" "Atools.boollist2sum" t "";
if term2str pred = "boollist2sum\n [b1 = k - 2 * q, b2 = k - 2 * q, b3 = k - 2 * q, b4 = k - 2 * q] =\nb1 + b2 + b3 + b4" then () 
else error "atools.sml diff.behav. in eval_boollist2sum";

trace_rewrite := false;
val srls_ = append_rls "srls_..Berechnung-erstSymbolisch" e_rls 
		      [Calc ("Atools.boollist2sum", eval_boollist2sum "")];
val t = str2t 
       "boollist2sum [b1 = k - 2*q, b2 = k - 2*q, b3 = k - 2*q, b4 = k - 2*q]";
case rewrite_set_ thy false srls_ t of SOME _ => ()
| _ => error "atools.sml diff.rewrite boollist2sum";
trace_rewrite:=false;


"----------- Matthias Goldgruber 2003 rewrite orders ----";
"----------- Matthias Goldgruber 2003 rewrite orders ----";
"----------- Matthias Goldgruber 2003 rewrite orders ----";
(* MK die ersten Tests *)
  val substa = [(e_term, (Thm.term_of o the o (parse thy)) "a")];
  val substb = [(e_term, (Thm.term_of o the o (parse thy)) "b")];
  val substx = [(e_term, (Thm.term_of o the o (parse thy)) "x")];

  val x1 = (Thm.term_of o the o (parse thy)) "a + b + x";
  val x2 = (Thm.term_of o the o (parse thy)) "a + x + b";
  val x3 = (Thm.term_of o the o (parse thy)) "a + x + b";
  val x4 = (Thm.term_of o the o (parse thy)) "x + a + b";

if ord_make_polynomial_in true thy substx (x1,x2) = true(*LESS *) then ()
else error "termorder.sml diff.behav ord_make_polynomial_in #1";
 
if ord_make_polynomial_in true thy substa (x1,x2) = true(*LESS *) then ()
else error "termorder.sml diff.behav ord_make_polynomial_in #2";

if ord_make_polynomial_in true thy substb (x1,x2) = false(*GREATER*) then ()
else error "termorder.sml diff.behav ord_make_polynomial_in #3";

  val aa = (Thm.term_of o the o (parse thy)) "-1 * a * x";
  val bb = (Thm.term_of o the o (parse thy)) "x^^^3";
  ord_make_polynomial_in true thy substx (aa, bb);
  true; (* => LESS *) 
  
  val aa = (Thm.term_of o the o (parse thy)) "-1 * a * x";
  val bb = (Thm.term_of o the o (parse thy)) "x^^^3";
  ord_make_polynomial_in true thy substa (aa, bb);
  false; (* => GREATER *)

(* und nach dem Re-engineering der Termorders in den 'rulesets' 
   kannst Du die 'gr"osste' Variable frei w"ahlen: *)
  val bdv= (Thm.term_of o the o (parse thy)) "bdv";
  val x  = (Thm.term_of o the o (parse thy)) "x";
  val a  = (Thm.term_of o the o (parse thy)) "a";
  val b  = (Thm.term_of o the o (parse thy)) "b";
val SOME (t',_) = rewrite_set_inst_ thy false [(bdv,a)] make_polynomial_in x2;
if term2str t' = "b + x + a" then ()
else error "termorder.sml diff.behav ord_make_polynomial_in #11";

val NONE = rewrite_set_inst_ thy false [(bdv,b)] make_polynomial_in x2;

val SOME (t',_) = rewrite_set_inst_ thy false [(bdv,x)] make_polynomial_in x2;
if term2str t' = "a + b + x" then ()
else error "termorder.sml diff.behav ord_make_polynomial_in #13";

  val ppp' = "-6 + -5*x + x^^^3 + -1*x^^^2 + -1*x^^^3 + -14*x^^^2";
  val ppp  = (Thm.term_of o the o (parse thy)) ppp';
val SOME (t',_) = rewrite_set_inst_ thy false [(bdv,x)] make_polynomial_in ppp;
if term2str t' = "-6 + -5 * x + -15 * x ^^^ 2 + 0" then ()
else error "termorder.sml diff.behav ord_make_polynomial_in #14";

val SOME (t',_) = rewrite_set_inst "Isac"false [("bdv","x")] "make_polynomial_in" ppp';
if t' = "-6 + -5 * x + -15 * x ^^^ 2 + 0" then ()
else error "termorder.sml diff.behav ord_make_polynomial_in #15";

  val ttt' = "(3*x + 5)/18";
  val ttt = (Thm.term_of o the o (parse thy)) ttt';
val SOME (uuu,_) = rewrite_set_inst_ thy false [(bdv,x)] make_polynomial_in ttt;
if term2str uuu = "(5 + 3 * x) / 18" then ()
else error "termorder.sml diff.behav ord_make_polynomial_in #16a";

(*============ inhibit exn WN120316 ==============================================
val SOME (uuu,_) = rewrite_set_ thy false make_polynomial ttt;
if term2str uuu = "(5 + 3 * x) / 18" then ()
else error "termorder.sml diff.behav ord_make_polynomial_in #16b";
============ inhibit exn WN120316 ==============================================*)


"----------- introduction by MG 2003 --------------------";
"----------- introduction by MG 2003 --------------------";
"----------- introduction by MG 2003 --------------------";
(*##################################################################################
-----------28.2.03: war nicht upgedatet und ausgeklammert in ROOT.ML-->Test_Isac.thy

  (*Aufgabe zum Einstieg in die Arbeit...*)
  val t = (Thm.term_of o the o (parse thy)) "a*b - (a+b)*x + x^^^2 = 0";
  (*ein 'ruleset' aus Poly.ML wird angewandt...*)
  val SOME (t,_) = rewrite_set_ thy Poly_erls false make_polynomial t;
  term2str t;
  "a * b + (-1 * (a * x) + (-1 * (b * x) + x ^^^ 2)) = 0";
  val SOME (t,_) = 
      rewrite_set_inst_ thy Poly_erls false [("bdv","a")] make_polynomial_in t;
  term2str t;
  "x ^^^ 2 + (-1 * (b * x) + (-1 * (x * a) + b * a)) = 0";
(* bei Verwendung von "size_of-term" nach MG :*)
(*"x ^^^ 2 + (-1 * (b * x) + (b * a + -1 * (x * a))) = 0"  !!! *)

  (*wir holen 'a' wieder aus der Klammerung heraus...*)
  val SOME (t,_) = rewrite_set_ thy Poly_erls false discard_parentheses t;
  term2str t;
   "x ^^^ 2 + -1 * b * x + -1 * x * a + b * a = 0";
(* "x ^^^ 2 + -1 * b * x + b * a + -1 * x * a = 0" !!! *)

  val SOME (t,_) =
      rewrite_set_inst_ thy Poly_erls false [("bdv","a")] make_polynomial_in t;
  term2str t;
  "x ^^^ 2 + (-1 * (b * x) + a * (b + -1 * x)) = 0"; 
  (*da sind wir fast am Ziel: make_polynomial_in 'a' sollte ergeben
  "x ^^^ 2 + (-1 * (b * x)) + (b + -1 * x) * a = 0"*)

  (*das rewriting l"asst sich beobachten mit
trace_rewrite := false;
  *)

"------15.11.02 --------------------------";
  val t = (Thm.term_of o the o (parse thy)) "1 + a * x + b * x";
  val bdv = (Thm.term_of o the o (parse thy)) "bdv";
  val a = (Thm.term_of o the o (parse thy)) "a";
 
trace_rewrite := false;
 (* Anwenden einer Regelmenge aus Termorder.ML: *)
 val SOME (t,_) =
     rewrite_set_inst_ thy false [(bdv,a)] make_polynomial_in t;
 term2str t;
 val SOME (t,_) =
     rewrite_set_ thy false discard_parentheses t;
 term2str t;
"1 + b * x + x * a";

 val t = (Thm.term_of o the o (parse thy)) "1 + a * (x + b * x) + a^^^2";
 val SOME (t,_) =
     rewrite_set_inst_ thy false [(bdv,a)] make_polynomial_in t;
 term2str t;
 val SOME (t,_) =
     rewrite_set_ thy false discard_parentheses t;
 term2str t;
"1 + (x + b * x) * a + a ^^^ 2";

 val t = (Thm.term_of o the o (parse thy)) "1 + a ^^^2 * x + b * a + 7*a^^^2";
 val SOME (t,_) =
     rewrite_set_inst_ thy false [(bdv,a)] make_polynomial_in t;
 term2str t;
 val SOME (t,_) =
     rewrite_set_ thy false discard_parentheses t;
 term2str t;
"1 + b * a + (7 + x) * a ^^^ 2";

(* MG2003
 Atools.thy       grundlegende Algebra
 Poly.thy         Polynome
 Rational.thy     Br"uche
 Root.thy         Wurzeln
 RootRat.thy      Wurzen + Br"uche
 Termorder.thy    BITTE NUR HIERHER SCHREIBEN (...WN03)

 get_thm Termorder.thy "bdv_n_collect";
 get_thm (theory "Isac") "bdv_n_collect";
*)
 val t = (Thm.term_of o the o (parse thy)) "a ^^^2 * x + 7 * a^^^2";
 val SOME (t,_) =
     rewrite_set_inst_ thy false [(bdv,a)] make_polynomial_in t;
 term2str t;
 val SOME (t,_) =
     rewrite_set_ thy false discard_parentheses t;
 term2str t;
"(7 + x) * a ^^^ 2";

 val t = (Thm.term_of o the o (parse Termorder.thy)) "Pi";

 val t = (Thm.term_of o the o (parseold thy)) "7";
##################################################################################*)

"----------- fun eval_binop -----------------------------";
"----------- fun eval_binop -----------------------------";
"----------- fun eval_binop -----------------------------";
val (op_, ef) = the (assoc (calclist, "TIMES"));
val t = (Thm.term_of o the o (parse thy)) "2 * 3";
(*val SOME (thmid,t') = *)get_pair thy op_ ef t;
;
"~~~~~ fun get_pair, args:"; val (thy, op_, ef, (t as (Const (op0,_) $ t1 $ t2))) =
  (thy, op_, ef, t);
op_ = op0 = true;
ef op_ t thy
;
"~~~~~ fun eval_binop, args:"; val ((thmid : string), (op_: string), 
      (t as (Const (op0, t0) $ t1 $ t2)), _) = ("#mult_", op_, t, thy); (* binary . n1.(n2.v) *)
val (SOME n1, SOME n2) = (numeral t1, numeral t2)
          val (_, _, Trange) = dest_binop_typ t0;
          val res = calcul op0 n1 n2;
          val rhs = term_of_float Trange res;
          val prop = Trueprop $ (mk_equality (t, rhs));
val SOME (thmid, tm) = SOME ("#: " ^ term2str prop, prop)
;
if thmid = "#: 2 * 3 = 6" andalso term2str prop = "2 * 3 = 6" then ()
else error "eval_binop changed"
;
val SOME (thmid, tm) = eval_binop "#mult_"  op_ t thy;
if thmid = "#: 2 * 3 = 6" andalso term2str prop = "2 * 3 = 6" then ()
else error "eval_binop changed 2"

