(* tests on biegelinie
   author: Walther Neuper 050826
   (c) due to copyright terms
*)
trace_rewrite := false;
"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- the rules -------------------------------------------";
"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
"----------- simplify_leaf for this script -----------------------";
"----------- Bsp 7.27 me -----------------------------------------";
"----------- Bsp 7.27 autoCalculate ------------------------------";
"----------- SubProblem (_,[vonBelastungZu,Biegelinien] ----------";
"----------- SubProblem (_,[setzeRandbedingungen,Biegelinien] ----";
"----------- method [Biegelinien,setzeRandbedingungenEin] + exec -";
"----------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. --------";
"----------- investigate normalforms in biegelinien --------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";

val thy = @{theory "Biegelinie"};
val ctxt = thy2ctxt' "Biegelinie";
fun str2term str = (Thm.term_of o the o (parse thy)) str;
fun term2s t = term_to_string'' "Biegelinie" t;
fun rewrit thm str = 
    fst (the (rewrite_ thy tless_true e_rls true thm str));

"----------- the rules -------------------------------------------";
"----------- the rules -------------------------------------------";
"----------- the rules -------------------------------------------";
val t = rewrit @{thm Belastung_Querkraft} (str2term "- qq x = - q_0"); term2s t;
if term2s t = "Q' x = - q_0" then ()
else error  "/biegelinie.sml: Belastung_Querkraft";

val t = rewrit @{thm Querkraft_Moment} (str2term "Q x = - q_0 * x + c"); term2s t;
if term2s t = "M_b' x = - q_0 * x + c" then ()
else error  "/biegelinie.sml: Querkraft_Moment";

val t = rewrit @{thm Moment_Neigung} (str2term "M_b x = -q_0 * x^^^2/2 + q_0/2 *L*x");
    term2s t;
if term2s t = "- EI * y'' x = - q_0 * x ^^^ 2 / 2 + q_0 / 2 * L * x" then ()
else error  "biegelinie.sml: Moment_Neigung";

"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
val t = str2term "M_b x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2";
val t = rewrit @{thm Moment_Neigung} t;
if term2s t = "- EI * y'' x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2" then ()
else error "Moment_Neigung broken";
(* was       I * ?y'' x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2"
   before declaring "y''" as a constant *)

val t = rewrit @{thm make_fun_explicit} t; 
if term2s t = "y'' x = 1 / - EI * (L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2)" then ()
else error "make_fun_explicit broken";

"----------- simplify_leaf for this script -----------------------";
"----------- simplify_leaf for this script -----------------------";
"----------- simplify_leaf for this script -----------------------";
val srls = Rls {id="srls_IntegrierenUnd..", 
		preconds = [], 
		rew_ord = ("termlessI",termlessI), 
		erls = append_rls "erls_in_srls_IntegrierenUnd.." e_rls
				  [(*for asm in NTH_CONS ...*)
				   Calc ("Orderings.ord_class.less",eval_equ "#less_"),
				   (*2nd NTH_CONS pushes n+-1 into asms*)
				   Calc("Groups.plus_class.plus", eval_binop "#add_")
				   ], 
		srls = Erls, calc = [], errpatts = [],
		rules = [Thm ("NTH_CONS",num_str @{thm NTH_CONS}),
			 Calc("Groups.plus_class.plus", eval_binop "#add_"),
			 Thm ("NTH_NIL",num_str @{thm NTH_NIL}),
			 Calc("Tools.lhs", eval_lhs "eval_lhs_"),
			 Calc("Tools.rhs", eval_rhs "eval_rhs_"),
			 Calc("Atools.argument'_in", eval_argument_in "Atools.argument'_in")
			 ],
		scr = EmptyScr};
val rm_ = str2term"[M_b 0 = 0, M_b L = 0]";
val M__ = str2term"M_b x = -1 * x ^^^ 2 / 2 + x * c + c_2";
val SOME (e1__,_) = rewrite_set_ thy false srls 
  (str2term "(NTH::[real,bool list]=>bool) 1 " $ rm_);
if term2str e1__ = "M_b 0 = 0" then () else error "biegelinie.sml simplify NTH 1 rm_";

val SOME (x1__,_) = 
    rewrite_set_ thy false srls 
		 (str2term"argument_in (lhs (M_b 0 = 0))");
if term2str x1__ = "0" then ()
else error "biegelinie.sml simplify argument_in (lhs (M_b 0 = 0)";

(*trace_rewrite := true; ..stopped Test_Isac.thy*)
trace_rewrite:=false;

"----------- Bsp 7.27 me -----------------------------------------";
"----------- Bsp 7.27 me -----------------------------------------";
"----------- Bsp 7.27 me -----------------------------------------";
val fmz = ["Traegerlaenge L","Streckenlast q_0","Biegelinie y",
	   "RandbedingungenBiegung [y 0 = 0, y L = 0]",
	   "RandbedingungenMoment [M_b 0 = 0, M_b L = 0]",
	   "FunktionsVariable x"];
val (dI',pI',mI') =
  ("Biegelinie",["MomentBestimmte","Biegelinien"],
   ["IntegrierenUndKonstanteBestimmen"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;

val pits = get_obj g_pbl pt (fst p);writeln (itms2str_ ctxt pits);
(*if itms2str_ ctxt pits = ... all 5 model-items*)
val mits = get_obj g_met pt (fst p); writeln (itms2str_ ctxt mits);
if itms2str_ ctxt mits = "[]" then ()
else error  "biegelinie.sml: Bsp 7.27 #2";

val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_,Add_Given "FunktionsVariable x") => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #4a";

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val mits = get_obj g_met pt (fst p);writeln (itms2str_ ctxt mits);
(*if itms2str_ ctxt mits = ... all 6 guard-items*)
case nxt of (_, Apply_Method ["IntegrierenUndKonstanteBestimmen"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #4b";

"===== Apply_Method IntegrierenUndKonstanteBestimmen ============================";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case pt of Nd (PblObj _, [Nd _]) => ((*Apply_Method + Take*))
	  | _ => error  "biegelinie.sml: Bsp 7.27 #4c";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;

case nxt of 
    (_,Subproblem ("Biegelinie", ["named", "integrate", "function"])) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #4c";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["diff", "integration", "named"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #5";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of 
    ("Check_Postcond", Check_Postcond ["named", "integrate", "function"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #5a";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of 
    (_, Subproblem ("Biegelinie", ["named", "integrate", "function"]))=>()
  | _ => error "biegelinie.sml: Bsp 7.27 #5b";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["diff", "integration","named"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #6";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt(*nxt = Check_Postcond ["named", "int..*);
f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of (_, Substitute ["x = 0"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #7";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "0 = c_2 + c * 0 + -1 * q_0 / 2 * 0 ^^^ 2" then ()
else error  "biegelinie.sml: Bsp 7.27 #8";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "0 = c_2 + c * L + -1 * q_0 / 2 * L ^^^ 2" then ()
else error  "biegelinie.sml: Bsp 7.27 #9";

(*val nxt = (+, Subproblem ("Biegelinie", ["normalize", ..lin..sys]))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["EqSystem", "normalize", "2x2"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #10";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
(*val nxt = Subproblem ["triangular", "2x2", "LINEAR", "system"]*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method["EqSystem", "top_down_substitution", "2x2"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #11";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of (_, Check_Postcond ["normalize", "2x2", "LINEAR", "system"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #12";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of
    (_, Subproblem ("Biegelinie", ["named", "integrate", "function"]))=>()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #13";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["diff", "integration", "named"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #14";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of
    (_, Check_Postcond ["named", "integrate", "function"]) => ()
  | _ => error  "biegelinie.sml: Bsp 7.27 #15";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f =
  "y' x = c + 1 / (-1 * EI) * (L * q_0 / 4 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)"
then () else error  "biegelinie.sml: Bsp 7.27 #16 f";
case nxt of
    (_, Subproblem ("Biegelinie", ["named", "integrate", "function"]))=>()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #16";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["diff", "integration", "named"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #17";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = 
   "y x =\nc_2 + c * x +\n\
   \1 / (-1 * EI) * (L * q_0 / 12 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)"
then () else error  "biegelinie.sml: Bsp 7.27 #18 f";
case nxt of
    (_, Check_Postcond ["named", "integrate", "function"]) => ()
  | _ => error  "biegelinie.sml: Bsp 7.27 #18";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of
    (_, Subproblem
            ("Biegelinie", ["normalize", "2x2", "LINEAR", "system"])) => ()
  | _ => error  "biegelinie.sml: Bsp 7.27 #19";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["EqSystem", "normalize", "2x2"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #20";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "[c_2 = 0, L * c + c_2 = -1 * q_0 * L ^^^ 4 / (-24 * EI)]" then ()
else error  "biegelinie.sml: Bsp 7.27 #21 f";
case nxt of
    (_, Subproblem
            ("Biegelinie", ["triangular", "2x2", "LINEAR", "system"])) =>()
  | _ => error  "biegelinie.sml: Bsp 7.27 #21";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method["EqSystem", "top_down_substitution", "2x2"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #22";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of (_, Check_Postcond ["normalize", "2x2", "LINEAR", "system"]) => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #23";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = 
"y x =\n-1 * q_0 * L ^^^ 4 / (-24 * EI * L) * x +\n\
 \(2 * L * q_0 / (-1 * 24 * EI) * x ^^^ 3 +\n\
 \ -1 * q_0 / (-1 * 24 * EI) * x ^^^ 4)" then ()
else error  "biegelinie.sml: Bsp 7.27 #24 f";
case nxt of ("End_Proof'", End_Proof') => ()
	  | _ => error  "biegelinie.sml: Bsp 7.27 #24";

show_pt pt;
(*(([], Frm), Problem (Biegelinie.thy, [MomentBestimmte, Biegelinien])),
(([1], Frm), q_ x = q_0),
(([1], Res), - q_ x = - q_0),
(([2], Res), Q' x = - q_0),
(([3], Pbl), Integrate (- q_0, x)),
(([3,1], Frm), Q x = Integral - q_0 D x),
(([3,1], Res), Q x = -1 * q_0 * x + c),
(([3], Res), Q x = -1 * q_0 * x + c),
(([4], Res), M_b' x = -1 * q_0 * x + c),
(([5], Pbl), Integrate (-1 * q_0 * x + c, x)),
(([5,1], Frm), M_b x = Integral -1 * q_0 * x + c D x),
(([5,1], Res), M_b x = -1 * q_0 * x ^^^ 2 / 2 + x * c + c_2),
(([5], Res), M_b x = -1 * q_0 * x ^^^ 2 / 2 + x * c + c_2),
(([6], Res), M_b 0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2),
(([7], Res), 0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2),
(([8], Res), M_b L = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2),
(([9], Res), 0 = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2),
(([10], Pbl), solveSystem [0 = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2] [c_2]),
(([10,1], Frm), [0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2,
 0 = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2]),
(([10,1], Res), [0 = c_2, 0 = -1 * (q_0 * L ^^^ 2) / 2 + (L * c + c_2)]),
(([10,2], Res), [c_2 = 0, L * c + c_2 = 0 + -1 * (-1 * (q_0 * L ^^^ 2) / 2)]),
(([10,3], Res), [c_2 = 0, L * c + c_2 = q_0 * L ^^^ 2 / 2]),
(([10,4], Pbl), solveSystem [L * c + c_2 = q_0 * L ^^^ 2 / 2] [c_2]),
(([10,4,1], Frm), L * c + c_2 = q_0 * L ^^^ 2 / 2),
(([10,4,1], Res), L * c + 0 = q_0 * L ^^^ 2 / 2),
(([10,4,2], Res), L * c = q_0 * L ^^^ 2 / 2),
(([10,4,3], Res), c = q_0 * L ^^^ 2 / 2 / L),
(([10,4,4], Res), c = L * q_0 / 2),
(([10,4,5], Res), [c = L * q_0 / 2, c_2 = 0]),
(([10,4], Res), [c = L * q_0 / 2, c_2 = 0]),
(([10], Res), [c = L * q_0 / 2, c_2 = 0]),
(([11], Res), M_b x = -1 * q_0 * x ^^^ 2 / 2 + x * (L * q_0 / 2) + 0),
(([12], Res), M_b x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2),
(([13], Res), EI * y'' x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2),
(([14], Res), y'' x = 1 / EI * (L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2)),
(([15], Pbl), Integrate (1 / EI * (L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2), x)),
(([15,1], Frm), y' x = Integral 1 / EI * (L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2) D x),
(([15,1], Res), y' x =
(Integral L * q_0 * x / 2 D x + Integral -1 * q_0 * x ^^^ 2 / 2 D x) / EI +
c)]*)

"----------- Bsp 7.27 autoCalculate ------------------------------";
"----------- Bsp 7.27 autoCalculate ------------------------------";
"----------- Bsp 7.27 autoCalculate ------------------------------";
 reset_states ();
 CalcTree [(["Traegerlaenge L","Streckenlast q_0","Biegelinie y",
	     "RandbedingungenBiegung [y 0 = 0, y L = 0]",
	     "RandbedingungenMoment [M_b 0 = 0, M_b L = 0]",
	     "FunktionsVariable x"],
	    ("Biegelinie",
	     ["MomentBestimmte","Biegelinien"],
	     ["IntegrierenUndKonstanteBestimmen"]))];
 moveActiveRoot 1;
 autoCalculate 1 CompleteCalcHead; 

 fetchProposedTactic 1 (*->"Apply_Method" IntegrierenUndKonstanteBestimmen*);
(*
> val (_,Apply_Method' (_, NONE, ScrState is), _)::_ = tacis;
> is = e_scrstate;
val it = true : bool
*)
 autoCalculate 1 (Step 1) (*->GENERATED ([1], Frm)*);
 val ((pt,_),_) = get_calc 1;
 case pt of Nd (PblObj _, [Nd _]) => ((*Apply_Method + Take*))
	  | _ => error  "biegelinie.sml: Bsp 7.27 autoCalculate#4c";

 autoCalculate 1 CompleteCalc;  
val ((pt,p),_) = get_calc 1;
if p = ([], Res) andalso length (children pt) = 23 andalso 
term2str (get_obj g_res pt (fst p)) = 
"y x =\n-1 * q_0 * L ^^^ 4 / (-24 * EI * L) * x +\n(2 * L * q_0 / (-1 * 24 * EI) * x ^^^ 3 +\n -1 * q_0 / (-1 * 24 * EI) * x ^^^ 4)"
then () else error "biegelinie.sml: 1st biegelin.7.27 changed";

 val (unc, del, gen) = (([],Pbl), ([],Pbl), ([],Res));
 getFormulaeFromTo 1 unc gen 1 (*only level 1*) false;
 show_pt pt;

(*check all formulae for getTactic*)
 getTactic 1 ([1],Frm) (*see smltest/../reverse-rew.sml*);
 getTactic 1 ([5],Res) (*tac2xml: not impl. for Substitute ["x = 0"]*);
 getTactic 1 ([6],Res) (* ---"---                      ["M_b 0 = 0"]*);
 getTactic 1 ([7],Res) (*!!!!!Take!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*);
 getTactic 1 ([8],Frm) (*tac2xml: not impl. for Substitute ["x = L"]*);
 getTactic 1 ([8],Res) (* ---"---                      ["M_b L = 0"]*);


"----------- SubProblem (_,[vonBelastungZu,Biegelinien] ----------";
"----------- SubProblem (_,[vonBelastungZu,Biegelinien] ----------";
"----------- SubProblem (_,[vonBelastungZu,Biegelinien] ----------";
val fmz = 
    ["Streckenlast q_0","FunktionsVariable x",
     "Funktionen [Q x = c + -1 * q_0 * x, \
     \M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2,\
     \ y' x = c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3),\
     \ y x = c_4 + c_3 * x + 1 / (-1 * EI) * (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)]"];
val (dI',pI',mI') = ("Biegelinie", ["vonBelastungZu","Biegelinien"],
		     ["Biegelinien","ausBelastung"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of ("Apply_Method", Apply_Method ["Biegelinien", "ausBelastung"]) => ()
| _ => error "biegelinie.sml met2 b";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =   "q_ x = q_0";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "- q_ x = - q_0";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =  "Q' x = - q_0";
case nxt of (_, Subproblem (_, ["named", "integrate", "function"])) => ()
| _ => error "biegelinie.sml met2 c";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "Q x = c + -1 * q_0 * x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "Q x = c + -1 * q_0 * x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "M_b' x = c + -1 * q_0 * x";
case nxt of (_,Subproblem (_, ["named", "integrate", "function"])) => ()
| _ => error "biegelinie.sml met2 d";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
		   "M_b x = Integral c + -1 * q_0 * x D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
		   "M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
		   "M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
		   "- EI * y'' x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
		   "y'' x = 1 / - EI * (c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2)";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
    "y' x = Integral 1 / - EI * (c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2) D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y' x = Integral 1 / (-1 * EI) * (c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2) D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y' x =\nc_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y' x =\nc_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y x =\nIntegral c_3 +\n         1 / (-1 * EI) *\n         (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3) D x";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
"y x =\nc_4 + c_3 * x +\n1 / (-1 * EI) *\n(c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
   "y x =\nc_4 + c_3 * x +\n1 / (-1 * EI) *\n(c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; 
if f2str f =
   "[Q x = c + -1 * q_0 * x, M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2,\n y' x =\n c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3),\n y x =\n c_4 + c_3 * x +\n 1 / (-1 * EI) *\n (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)]"
then case nxt of ("End_Proof'", End_Proof') => ()
  | _ => error "biegelinie.sml met2 e 1"
else error "biegelinie.sml met2 e 2";

"----------- SubProblem (_,[setzeRandbedingungen,Biegelinien] ----";
"----------- SubProblem (_,[setzeRandbedingungen,Biegelinien] ----";
"----------- SubProblem (_,[setzeRandbedingungen,Biegelinien] ----";
val fmz = ["functionEq (M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2)", 
	   "substitution (M_b L = 0)", 
	   "equality equ_equ"];
val (dI',pI',mI') = ("Biegelinie", ["makeFunctionTo","equation"],
		     ["Equation","fromFunction"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
			"M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
                        "M_b L = c_2 + c * L + -1 * q_0 / 2 * L ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = 
			"0 = c_2 + c * L + -1 * q_0 / 2 * L ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if (* f2str f = "0 = c_2 + L * c + -1 * q_0 / 2 * L ^^^ 2" CHANGE NOT considered, already on leave*)
   f2str f = "0 = (2 * c_2 + 2 * L * c + -1 * L ^^^ 2 * q_0) / 2"
then case nxt of ("End_Proof'", End_Proof') => ()
  | _ => error "biegelinie.sml: SubProblem (_,[setzeRandbed 1"
else error "biegelinie.sml: SubProblem (_,[setzeRandbed 2";


"----------- method [Biegelinien,setzeRandbedingungenEin] + exec -";
"----------- method [Biegelinien,setzeRandbedingungenEin] + exec -";
"----------- method [Biegelinien,setzeRandbedingungenEin] + exec -";
"----- check the scripts syntax";
"----- execute script by interpreter: setzeRandbedingungenEin";
val fmz = ["Funktionen [Q x = c + -1 * q_0 * x," ^
    "M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2," ^
    "y' x = c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)," ^
    "y x = c_4 + c_3 * x + 1 / (-1 * EI) * (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)]",
	   "Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]",
	   "Gleichungen equ_s"];
val (dI',pI',mI') = ("Biegelinie", ["setzeRandbedingungen","Biegelinien"],
		     ["Biegelinien","setzeRandbedingungenEin"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;

"--- before 1.subpbl [Equation, fromFunction]";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Biegelinien", "setzeRandbedingungenEin"])=>()
| _ => error "biegelinie.sml: met setzeRandbed*Ein aa";
"----- Randbedingung y 0 = 0 in SUBpbl with met [Equation, fromFunction]";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
if (#1 o (get_obj g_fmz pt)) (fst p) =
   ["functionEq\n (y x =\n  c_4 + c_3 * x +\n  1 / (-1 * EI) *" ^
     "\n  (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4))",
     "substitution (y 0 = 0)", "equality equ'''"] then ()
else error "biegelinie.sml met setzeRandbed*Ein bb";
(writeln o istate2str) (get_istate pt p);
"--- after 1.subpbl [Equation, fromFunction]";

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method["Equation", "fromFunction"]) => ()
| _ => error "biegelinie.sml met2 ff";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f =
   "y x =\nc_4 + c_3 * x +\n1 / (-1 * EI) *\n(c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Check_Postcond ["makeFunctionTo", "equation"]) => ()
| _ => error "biegelinie.sml met2 gg";

"--- before 2.subpbl [Equation, fromFunction]";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 = c_4 + 0 / (-1 * EI)" ;
case nxt of (_,Subproblem (_, ["makeFunctionTo", "equation"])) => ()
| _ => error "biegelinie.sml met2 hh";
"--- after 1st arrival at 2.subpbl [Equation, fromFunction]";

val (p,_,f,nxt,_,pt) = me nxt p c pt; 
if (#1 o (get_obj g_fmz pt)) (fst p) =
    ["functionEq\n (y x =\n  c_4 + c_3 * x +\n  1 / (-1 * EI) *\n  (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4))",
      "substitution (y L = 0)", "equality equ'''"] then ()
else error "biegelinie.sml metsetzeRandbed*Ein bb ";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;

val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method["Equation", "fromFunction"]) => ()
| _ => error "biegelinie.sml met2 ii";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "y x =\nc_4 + c_3 * x +\n1 / (-1 * EI) *\n(c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "y L =\nc_4 + c_3 * L +\n1 / (-1 * EI) *\n(c_2 / 2 * L ^^^ 2 + c / 6 * L ^^^ 3 + -1 * q_0 / 24 * L ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 =\nc_4 + c_3 * L +\n1 / (-1 * EI) *\n(c_2 / 2 * L ^^^ 2 + c / 6 * L ^^^ 3 + -1 * q_0 / 24 * L ^^^ 4)";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 =\nc_4 + L * c_3 +\n(12 * L ^^^ 2 * c_2 + 4 * L ^^^ 3 * c + -1 * L ^^^ 4 * q_0) / (-24 * EI)" ;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 =\nc_4 + L * c_3 +\n(12 * L ^^^ 2 * c_2 + 4 * L ^^^ 3 * c + -1 * L ^^^ 4 * q_0) / (-24 * EI)";
case nxt of (_,Subproblem (_, ["makeFunctionTo", "equation"])) => ()
| _ => error "biegelinie.sml met2 jj";

val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Equation", "fromFunction"])=>()
| _ => error "biegelinie.sml met2 kk";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2"(*true*);
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 = c_2 + c * 0 + -1 * q_0 / 2 * 0 ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 = c_2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 = c_2";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*========== inhibit exn WN1130722 Isabelle2012-->13 thehier? works in Test_Some===

case nxt of (_, Subproblem (_, ["makeFunctionTo", "equation"])) => ()
| _ => error "biegelinie.sml met2 ll";

val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Equation", "fromFunction"])=>()
| _ => error "biegelinie.sml met2 mm";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "M_b L = c_2 + c * L + -1 * q_0 / 2 * L ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 = c_2 + c * L + -1 * q_0 / 2 * L ^^^ 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 = (2 * c_2 + 2 * L * c + -1 * L ^^^ 2 * q_0) / 2";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f = "0 = (2 * c_2 + 2 * L * c + -1 * L ^^^ 2 * q_0) / 2";
case nxt of (_, Check_Postcond ["setzeRandbedingungen", "Biegelinien"]) => ()
| _ => error "biegelinie.sml met2 nn";
val (p,_,f,nxt,_,pt) = me nxt p c pt; 
if nxt = ("End_Proof'", End_Proof') andalso f2str f =
(* "[0 = c_4,\n 0 =\n c_4 + L * c_3 +\n (12 * L ^^^ 2 * c_2 + 4 * L ^^^ 3 * c + -1 * L ^^^ 4 * q_0) / (-24 * EI),\n 0 = c_2, 0 = (2 * c_2 + 2 * L * c + -1 * L ^^^ 2 * q_0) / 2]" *)
"[0 = c_4,\n 0 =\n c_4 + L * c_3 +\n (12 * L ^^^ 2 * c_2 + 4 * L ^^^ 3 * c + -1 * L ^^^ 4 * q_0) /\n (-1 * EI * 24),\n 0 = c_2, 0 = (2 * c_2 + 2 * L * c + -1 * L ^^^ 2 * q_0) / 2]"
then () else error "biegelinie.sml met2 oo";
============ inhibit exn WN1130722 Isabelle2012-->13 thehier? works in Test_Some=*)

"----------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. --------";
"----------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. --------";
"----------- IntegrierenUndKonstanteBestimmen2: Bsp.7.70. --------";
"----- Bsp 7.70 with me";
val fmz = ["Traegerlaenge L","Streckenlast q_0","Biegelinie y",
	     "Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]",
	     "FunktionsVariable x"];
val (dI',pI',mI') = ("Biegelinie", ["Biegelinien"],
		     ["IntegrierenUndKonstanteBestimmen2"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*========== inhibit exn WN1130722 Isabelle2012-->13 thehier? works in Test_Some===
if nxt = ("Apply_Method", Apply_Method ["IntegrierenUndKonstanteBestimmen2"])
then () else error "biegelinie.sml met2 a";

(*** actual arg(s) missing for '["(#Find, (Funktionen, funs_))"]' i.e. should be 'copy-named' by '*_._'
... THIS MEANS: 
#a# "Script Biegelinie2Script ..
"         ... (SubProblem (Biegelinie_,[vonBelastungZu,Biegelinien],      " ^
"                          [Biegelinien,ausBelastung])                    " ^
"                          [REAL q__, REAL v_]);                         "

#b# prep_met ... (["Biegelinien","ausBelastung"],
              ... ("#Given" ,["Streckenlast q__","FunktionsVariable v_v"]),
   "Script Belastung2BiegelScript (q__::real) (v_v::real) =                 "

#a#b# BOTH HAVE 2 ARGUMENTS q__ and v_v ...OK
##########################################################################
BUT THE (#Find, (Funktionen, funs_)) IS NOT COPYNAMED BY funs___ !!!3*_!!!
##########################################################################*)
"further 'me' see ----- SubProblem (_,[vonBelastungZu,Biegelinien] -------" ^
"                 ----- SubProblem (_,[setzeRandbedingungen,Biegelinien] -";

DEconstrCalcTree 1;
"----- Bsp 7.70 with autoCalculate";
CalcTree [(["Traegerlaenge L","Streckenlast q_0","Biegelinie y",
	     "Randbedingungen [Q 0 = q_0 * L, M_b L = 0, y 0 = 0, y' 0 = 0]",
	     "FunktionsVariable x"],
	    ("Biegelinie", ["Biegelinien"],
		     ["IntegrierenUndKonstanteBestimmen2"]))];
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; show_pt pt;
if p = ([], Res) andalso term2str (get_obj g_res pt (fst p)) =
"y x =\n-6 * q_0 * L ^^^ 2 / (-24 * EI) * x ^^^ 2 +\n4 * L * q_0 / (-24 * EI) * x ^^^ 3 +\n-1 * q_0 / (-24 * EI) * x ^^^ 4" then ()
else error "biegelinie.sml: diff.behav.7.70 with autoCalculate";

val is = get_istate pt ([],Res); writeln (istate2str is);
val t = str2term (" last                                                     " ^
"[Q x = L * q_0 + -1 * q_0 * x,                                              " ^
" M_b x = -1 * q_0 * L ^^^ 2 / 2 + q_0 * L / 1 * x + -1 * q_0 / 2 * x ^^^ 2," ^
" y' x =                                                                    " ^
"  -3 * q_0 * L ^^^ 2 / (-6 * EI) * x + 3 * L * q_0 / (-6 * EI) * x ^^^ 2 +" ^
"  -1 * q_0 / (-6 * EI) * x ^^^ 3,                                         " ^
" y x =                                                                    " ^
"  -6 * q_0 * L ^^^ 2 / (-24 * EI) * x ^^^ 2 +                              " ^
"  4 * L * q_0 / (-24 * EI) * x ^^^ 3 +                                     " ^
"  -1 * q_0 / (-24 * EI) * x ^^^ 4]");
val srls = append_rls "erls_IntegrierenUndK.." e_rls 
		      [Calc("Tools.rhs", eval_rhs"eval_rhs_"),
		       Calc ("Atools.ident",eval_ident "#ident_"),
		       Thm ("last_thmI",num_str @{thm last_thmI}),
		       Thm ("if_True",num_str @{thm if_True}),
		       Thm ("if_False",num_str @{thm if_False})
		       ]
		      ;
val t = str2term "last [1,2,3,4]";
(*trace_rewrite := true; ..stopped Test_Isac.thy*)
val SOME (e1__,_) = rewrite_set_ thy false srls t;
trace_rewrite := false;
term2str e1__;
============ inhibit exn WN1130722 Isabelle2012-->13 thehier? works in Test_Some=*)

"----------- investigate normalforms in biegelinien --------------";
"----------- investigate normalforms in biegelinien --------------";
"----------- investigate normalforms in biegelinien --------------";
"----- coming from integration:";
val Q = str2term "Q x = c + -1 * q_0 * x";
val M_b = str2term "M_b x = c_2 + c * x + -1 * q_0 / 2 * x ^^^ 2";
val y' = str2term "y' x = c_3 + 1 / (-1 * EI) * (c_2 * x + c / 2 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)";
val y = str2term "y x = c_4 + c_3 * x +\n1 / (-1 * EI) * (c_2 / 2 * x ^^^ 2 + c / 6 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)";
(*^^^  1 / (-1 * EI) NOT distributed - ok! ^^^^^^^^^^^^^^^^^^^^^^^*)

"----- functions comming from:";


